<?php

require 'SsoProtocol.php';

class SsoSocket {
	// 수신
	public function recv($socket) {

		$ssoProtocol = new SsoProtocol();

		// SENDER
		$ssoProtocol->sender = socket_read($socket, 1, PHP_BINARY_READ);

		// RECEIVER
		$ssoProtocol->receiver = socket_read($socket, 1, PHP_BINARY_READ);

		// CMD
		$ssoProtocol->cmd = unpack("n", socket_read($socket, 2, PHP_BINARY_READ))[1];
		
		// ERROR
		$ssoProtocol->error = unpack("n", socket_read($socket, 2, PHP_BINARY_READ))[1];

		// WARNING
		$ssoProtocol->warn = unpack("n", socket_read($socket, 2, PHP_BINARY_READ))[1];

		// RESERVED1
		$ssoProtocol->reserved1 = unpack("N", socket_read($socket, 4, PHP_BINARY_READ))[1];

		// RESERVED2
		$ssoProtocol->reserved2 = unpack("N", socket_read($socket, 4, PHP_BINARY_READ))[1];

		// dataLength1
		$ssoProtocol->dataLength1 = unpack("N", socket_read($socket, 4, PHP_BINARY_READ))[1];

		// dataLength2
		$ssoProtocol->dataLength2 = unpack("N", socket_read($socket, 4, PHP_BINARY_READ))[1];

		// DATA1
		if ($ssoProtocol->dataLength1 > 0) {
			$ssoProtocol->data1 = socket_read($socket, $ssoProtocol->dataLength1);
		}

		// DATA2
		if ($ssoProtocol->dataLength2 > 0) {
			$ssoProtocol->data2 = socket_read($socket, $ssoProtocol->dataLength2);
		}
		
		return $ssoProtocol;
	}

	// HELLO 수신
	public function recvHello($socket) {

		$message = socket_read($socket, 64, PHP_BINARY_READ);
		
		return $message;
	}

	// 전송
	public function send($socket, $ssoProtocol) {

		socket_write($socket, $ssoProtocol->sender, 1);
		socket_write($socket, $ssoProtocol->receiver, 1);
		socket_write($socket, pack("n", $ssoProtocol->cmd), 2);
		socket_write($socket, pack("n", $ssoProtocol->error), 2);
		socket_write($socket, pack("n", $ssoProtocol->warn), 2);
		socket_write($socket, pack("N", $ssoProtocol->reserved1), 4);
		socket_write($socket, pack("N", $ssoProtocol->reserved2), 4);			
		socket_write($socket, pack("N", $ssoProtocol->dataLength1), 4);
		socket_write($socket, pack("N", $ssoProtocol->dataLength2), 4);

		// DATA1
		if ($ssoProtocol->dataLength1 > 0) {
			socket_write($socket, $ssoProtocol->data1, $ssoProtocol->dataLength1);
		}
			
		// DATA2
		if ($ssoProtocol->dataLength2 > 0) {
			socket_write($socket, $ssoProtocol->data2, $ssoProtocol->dataLength2);
		}
	}
}
?>