<?php

require 'Sso.php';

////////////////////////////////////////////////
//////////////////// 토큰 발행 ////////////////////
////////////////////////////////////////////////

// SSO 객체 생성
$sso = new Sso();

// 사용자의 기본 인적사항 [필수]
$sso->setUserId("lee");
$sso->setClientIp("192.168.0.2");

// 사용자의 부가적인 인적사항 [옵션]
$sso->setProfile("userName", "홍길동");
$sso->setProfile("deptCode", "A1000");
$sso->setProfile("deptName", "조선시대 의적");
$sso->setProfile("handphone", "010-0000-0000");
$sso->setProfile("email", "rivestsoft@gmail.com");
$sso->setProfile("age", "20");
$sso->setProfile("birth", "19901215");

// SSO Server의 IP와 PORT 설정 [옵션]
$sso->setServerIp("localhost");
$sso->setServerPort(8420);

// 토큰 발행 요청
$sso->issueToken();

// 에러체크
if($sso->getError() < 0) {
	echo "에러발생" . $sso->getError();
	return;
}

// 토큰을 쿠키에 저장
setcookie("ssoToken", $sso->getToken(), time() + 24 * 3600, "/");

echo "발급받은 토큰 : " . $sso->getToken() . "<br>";

////////////////////////////////////////////////
//////////////////// 토큰 검증 ////////////////////
////////////////////////////////////////////////

// 쿠키에서 토큰값 조회
$ssoToekn = $_COOKIE["ssoToken"];

// SSO 객체 생성
$sso = new Sso();

// 토큰 검증 요청시 필수값
$sso->setToken($ssoToekn);
$sso->setClientIp("192.168.0.2");

// SSO Agent의 PORT 설정 [옵션]
$sso->setAgentPort(8421);

// 토큰 검증 요청
$sso->verifyToken();

// 에러체크
if($sso->getError() < 0) {
	echo "에러발생" . $sso->getError();
	return;
}

// 사용자 정보
echo "userId : " . $sso->getUserId() . "<br>";
echo "userName : " . $sso->getProfile("userName") . "<br>";
echo "age : " . $sso->getProfile("age") . "<br>";

// TODO : 사용자 아이디로 로그인 처리

?>